| ARX 1.0 The next-generation open source augmented reality toolkit.

Loading...
Searching...
No Matches
Public Member Functions | List of all members
PlanarTracker::PlanarTrackerImpl Class Reference

## Public Member Functions
| PlanarTrackerImpl ()
void | Initialise (ARParam cParam)
cv::Mat | CreateFeatureMask (cv::Mat frame)
bool | CanDetectNewFeatures ()
bool | CanMatchNewFeatures (int detectedFeaturesSize)
void | MatchFeatures (std::vector< cv::KeyPoint > newFrameFeatures, cv::Mat newFrameDescriptors)
std::vector< cv::Point2f > | SelectTrackablePoints (int trackableIndex)
void | RunOpticalFlow (int trackableId, std::vector< cv::Point2f > trackablePoints, std::vector< cv::Point2f > trackablePointsWarped)
bool | UpdateTrackableHomography (int trackableId, std::vector< cv::Point2f > matchedPoints1, std::vector< cv::Point2f > matchedPoints2)
std::vector< cv::Point2f > | GetVerticesFromPoint (cv::Point ptOrig, int width=markerTemplateWidth, int height=markerTemplateWidth)
std::vector< cv::Point2f > | GetVerticesFromTopCorner (int x, int y, int width, int height)
cv::Rect | GetTemplateRoi (cv::Point2f pt)
bool | IsRoiValidForFrame (cv::Rect frameRoi, cv::Rect roi)
cv::Rect | InflateRoi (cv::Rect roi, int inflationFactor)
std::vector< cv::Point2f > | FloorVertexPoints (std::vector< cv::Point2f > vertexPoints)
cv::Mat | MatchTemplateToImage (cv::Mat searchImage, cv::Mat warpedTemplate)
void | RunTemplateMatching (cv::Mat frame, int trackableId)
void | BuildImagePyramid (cv::Mat frame)
void | SwapImagePyramid ()
void | ProcessFrameData (unsigned char *frame)
void | ProcessFrame (cv::Mat frame)
void | RemoveAllMarkers ()
bool | SaveTrackableDatabase (std::string fileName)
bool | LoadTrackableDatabase (std::string fileName)
void | AddMarker (std::shared_ptr< unsigned char > buff, std::string fileName, int width, int height, int uid, float scale)
bool | GetTrackablePose (int trackableId, float transMat[3][4])
bool | IsTrackableVisible (int trackableId)
void | CameraPoseFromPoints (cv::Mat &pose, std::vector< cv::Point3f > objPts, std::vector< cv::Point2f > imgPts)
bool | HasTrackables ()
bool | ChangeImageId (int prevId, int newId)
std::vector< int > | GetImageIds ()
TrackedImageInfo | GetTrackableImageInfo (int trackableId)
void | SetFeatureDetector (int detectorType)
int | GetFeatureDetector (void)
void | SetMaximumNumberOfMarkersToTrack (int maximumNumberOfMarkersToTrack)
int | GetMaximumNumberOfMarkersToTrack (void)

## Constructor & Destructor Documentation

## ◆ PlanarTrackerImpl()

PlanarTracker::PlanarTrackerImpl::PlanarTrackerImpl | ( |  | ) |
| inline

Here is the call graph for this function:

## Member Function Documentation

## ◆ AddMarker()

void PlanarTracker::PlanarTrackerImpl::AddMarker | ( | std::shared_ptr< unsigned char > | buff,
|  | std::string | fileName,
|  | int | width,
|  | int | height,
|  | int | uid,
|  | float | scale
| ) |  |
| inline

Here is the call graph for this function:

## ◆ BuildImagePyramid()

void PlanarTracker::PlanarTrackerImpl::BuildImagePyramid | ( | cv::Mat | frame | ) |
| inline

## ◆ CameraPoseFromPoints()

void PlanarTracker::PlanarTrackerImpl::CameraPoseFromPoints | ( | cv::Mat & | pose,
|  | std::vector< cv::Point3f > | objPts,
|  | std::vector< cv::Point2f > | imgPts
| ) |  |
| inline

## ◆ CanDetectNewFeatures()

bool PlanarTracker::PlanarTrackerImpl::CanDetectNewFeatures | ( |  | ) |
| inline

## ◆ CanMatchNewFeatures()

bool PlanarTracker::PlanarTrackerImpl::CanMatchNewFeatures | ( | int | detectedFeaturesSize | ) |
| inline

## ◆ ChangeImageId()

bool PlanarTracker::PlanarTrackerImpl::ChangeImageId | ( | int | prevId,
|  | int | newId
| ) |  |
| inline

## ◆ CreateFeatureMask()

cv::Mat PlanarTracker::PlanarTrackerImpl::CreateFeatureMask | ( | cv::Mat | frame | ) |
| inline

## ◆ FloorVertexPoints()

std::vector< cv::Point2f > PlanarTracker::PlanarTrackerImpl::FloorVertexPoints | ( | std::vector< cv::Point2f > | vertexPoints | ) |
| inline

## ◆ GetFeatureDetector()

int PlanarTracker::PlanarTrackerImpl::GetFeatureDetector | ( | void |  | ) |
| inline

## ◆ GetImageIds()

std::vector< int > PlanarTracker::PlanarTrackerImpl::GetImageIds | ( |  | ) |
| inline

## ◆ GetMaximumNumberOfMarkersToTrack()

int PlanarTracker::PlanarTrackerImpl::GetMaximumNumberOfMarkersToTrack | ( | void |  | ) |
| inline

## ◆ GetTemplateRoi()

cv::Rect PlanarTracker::PlanarTrackerImpl::GetTemplateRoi | ( | cv::Point2f | pt | ) |
| inline

## ◆ GetTrackableImageInfo()

TrackedImageInfo PlanarTracker::PlanarTrackerImpl::GetTrackableImageInfo | ( | int | trackableId | ) |
| inline

## ◆ GetTrackablePose()

bool PlanarTracker::PlanarTrackerImpl::GetTrackablePose | ( | int | trackableId,
|  | float | transMat[3][4]
| ) |  |
| inline

## ◆ GetVerticesFromPoint()

std::vector< cv::Point2f > PlanarTracker::PlanarTrackerImpl::GetVerticesFromPoint | ( | cv::Point | ptOrig,
|  | int | width = `markerTemplateWidth`,
|  | int | height = `markerTemplateWidth`
| ) |  |
| inline

## ◆ GetVerticesFromTopCorner()

std::vector< cv::Point2f > PlanarTracker::PlanarTrackerImpl::GetVerticesFromTopCorner | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |
| inline

## ◆ HasTrackables()

bool PlanarTracker::PlanarTrackerImpl::HasTrackables | ( |  | ) |
| inline

## ◆ InflateRoi()

cv::Rect PlanarTracker::PlanarTrackerImpl::InflateRoi | ( | cv::Rect | roi,
|  | int | inflationFactor
| ) |  |
| inline

## ◆ Initialise()

void PlanarTracker::PlanarTrackerImpl::Initialise | ( | ARParam | cParam | ) |
| inline

## ◆ IsRoiValidForFrame()

bool PlanarTracker::PlanarTrackerImpl::IsRoiValidForFrame | ( | cv::Rect | frameRoi,
|  | cv::Rect | roi
| ) |  |
| inline

## ◆ IsTrackableVisible()

bool PlanarTracker::PlanarTrackerImpl::IsTrackableVisible | ( | int | trackableId | ) |
| inline

## ◆ LoadTrackableDatabase()

bool PlanarTracker::PlanarTrackerImpl::LoadTrackableDatabase | ( | std::string | fileName | ) |
| inline

Here is the call graph for this function:

## ◆ MatchFeatures()

void PlanarTracker::PlanarTrackerImpl::MatchFeatures | ( | std::vector< cv::KeyPoint > | newFrameFeatures,
|  | cv::Mat | newFrameDescriptors
| ) |  |
| inline

Here is the call graph for this function:

## ◆ MatchTemplateToImage()

cv::Mat PlanarTracker::PlanarTrackerImpl::MatchTemplateToImage | ( | cv::Mat | searchImage,
|  | cv::Mat | warpedTemplate
| ) |  |
| inline

Do the Matching and Normalize

## ◆ ProcessFrame()

void PlanarTracker::PlanarTrackerImpl::ProcessFrame | ( | cv::Mat | frame | ) |
| inline

Here is the call graph for this function:

## ◆ ProcessFrameData()

void PlanarTracker::PlanarTrackerImpl::ProcessFrameData | ( | unsigned char * | frame | ) |
| inline

Here is the call graph for this function:

## ◆ RemoveAllMarkers()

void PlanarTracker::PlanarTrackerImpl::RemoveAllMarkers | ( |  | ) |
| inline

## ◆ RunOpticalFlow()

void PlanarTracker::PlanarTrackerImpl::RunOpticalFlow | ( | int | trackableId,
|  | std::vector< cv::Point2f > | trackablePoints,
|  | std::vector< cv::Point2f > | trackablePointsWarped
| ) |  |
| inline

Here is the call graph for this function:

## ◆ RunTemplateMatching()

void PlanarTracker::PlanarTrackerImpl::RunTemplateMatching | ( | cv::Mat | frame,
|  | int | trackableId
| ) |  |
| inline

Here is the call graph for this function:

## ◆ SaveTrackableDatabase()

bool PlanarTracker::PlanarTrackerImpl::SaveTrackableDatabase | ( | std::string | fileName | ) |
| inline

## ◆ SelectTrackablePoints()

std::vector< cv::Point2f > PlanarTracker::PlanarTrackerImpl::SelectTrackablePoints | ( | int | trackableIndex | ) |
| inline

## ◆ SetFeatureDetector()

void PlanarTracker::PlanarTrackerImpl::SetFeatureDetector | ( | int | detectorType | ) |
| inline

Here is the call graph for this function:

## ◆ SetMaximumNumberOfMarkersToTrack()

void PlanarTracker::PlanarTrackerImpl::SetMaximumNumberOfMarkersToTrack | ( | int | maximumNumberOfMarkersToTrack | ) |
| inline

## ◆ SwapImagePyramid()

void PlanarTracker::PlanarTrackerImpl::SwapImagePyramid | ( |  | ) |
| inline

## ◆ UpdateTrackableHomography()

bool PlanarTracker::PlanarTrackerImpl::UpdateTrackableHomography | ( | int | trackableId,
|  | std::vector< cv::Point2f > | matchedPoints1,
|  | std::vector< cv::Point2f > | matchedPoints2
| ) |  |
| inline

Here is the call graph for this function:

The documentation for this class was generated from the following file:

- Source/ARX/OCVT/PlanarTracker.cpp